package com.zhixinhuixue.anonymizer;

import com.github.dataanon.dsl.Blacklist;
import com.github.dataanon.model.DbConfig;
import com.github.dataanon.strategy.string.RandomString;
import com.github.dataanon.utils.RandomCharacterSets;
import com.zhixinhuixue.anonymizer.strategy.AnonPhoneStrategy;
import kotlin.Unit;

import java.util.ArrayList;
import java.util.Collections;

public class Anonymizer {

    private static String HOST_DB = "192.168.1.241:3306/zsy_ims_prod";
    private static String USER = "zsy";
    private static String PASSWORD = "HnTqLszKLNv6RR5b";


    public static void main(String[] args) {
        if (args.length == 3) {
            HOST_DB = args[0];
            USER = args[1];
            PASSWORD = args[2];
        }
        DbConfig source = new DbConfig("jdbc:mysql://" + HOST_DB + "?useUnicode=true&characterEncoding=UTF-8&autoReconnect=true&allowMultiQueries=true&serverTimezone=GMT%2B8", USER, PASSWORD);
        ArrayList<String> primaryKeys = new ArrayList<>();
        primaryKeys.add("supplier_id");
        new Blacklist(source).table("sys_supplier", primaryKeys, blacklistTable -> {
            blacklistTable.anonymize("contact").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("telephone").using(new AnonPhoneStrategy());
            return Unit.INSTANCE;
        }).table("cus_school_apply", Collections.singletonList("id"), blacklistTable -> {
            blacklistTable.anonymize("duty_person_name").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("duty_person_job").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("computer_person_name").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("device_person_name").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("computer_person_mobile").using(new AnonPhoneStrategy());
            blacklistTable.anonymize("device_person_mobile").using(new AnonPhoneStrategy());
            return Unit.INSTANCE;
        }).table("cus_school_contact", Collections.singletonList("id"), blacklistTable -> {
            blacklistTable.anonymize("school_master_name").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("school_master2_name").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("grade1_head_name").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("grade2_head_name").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("grade3_head_name").using(new RandomString(RandomCharacterSets.ALPHA));

            blacklistTable.anonymize("school_master_mobile").using(new AnonPhoneStrategy());
            blacklistTable.anonymize("school_master2_mobile").using(new AnonPhoneStrategy());
            blacklistTable.anonymize("grade1_head_mobile").using(new AnonPhoneStrategy());
            blacklistTable.anonymize("grade2_head_mobile").using(new AnonPhoneStrategy());
            blacklistTable.anonymize("grade3_head_mobile").using(new AnonPhoneStrategy());

            return Unit.INSTANCE;
        }).table("express_address", Collections.singletonList("ead_id"), blacklistTable -> {
            blacklistTable.anonymize("contact").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("mobile").using(new AnonPhoneStrategy());
            blacklistTable.anonymize("address").using(new RandomString(RandomCharacterSets.ALPHA));
            return Unit.INSTANCE;
        }).table("sys_express", Collections.singletonList("se_id"), blacklistTable -> {
            blacklistTable.anonymize("contact").using(new RandomString(RandomCharacterSets.ALPHA));
            blacklistTable.anonymize("mobile").using(new AnonPhoneStrategy());
            return Unit.INSTANCE;
        }).execute();
    }
}
