package com.zhixinhuixue.anonymizer.strategy;

import com.github.dataanon.model.Field;
import com.github.dataanon.model.Record;
import com.github.dataanon.strategy.AnonymizationStrategy;
import org.jetbrains.annotations.NotNull;

/**
 * 手机号验证
 *
 * @author gj
 * @date 2020年12月03日
 */
public class AnonPhoneStrategy implements AnonymizationStrategy<String> {
    @NotNull
    @Override
    public String anonymize(@NotNull Field<String> field, @NotNull Record record) {
        if (!field.isNull()) {
            String oldValue = field.getOldValue();
            return oldValue.replaceAll("(\\d{3})\\d{4}(\\d{4})", "$1****$2");
        }
        return "";
    }
}
